Subject: Re: RFC: Use of "jiffies" vs "jiffies64" in the neighbour system.

From: Ulf Samuelsson <[email-masked]>
Date: Wed, 25 Mar 2015 13:35:51 +0100

On 03/25/2015 11:27 AM, Michal Kubecek wrote:
> On Wed, Mar 25, 2015 at 11:11:45AM +0100, Ulf Samuelsson wrote:
>> If you run HZ = 1000, then jiffies will wrap around after 49,71 days.
>> This means that all time compares in the neighbour system will fail.
>>
>>  From what I can see from "jiffies,h" there is no attempt to detect
>> the wrap-around.
>>
>> #define time_after(a,b)        \
>>      (typecheck(unsigned long, a) && \
>>       typecheck(unsigned long, b) && \
>>       ((long)(b) - (long)(a) < 0))
>> #define time_before(a,b)    time_after(b,a)
>>
>> #define time_after_eq(a,b)    \
>>      (typecheck(unsigned long, a) && \
>>       typecheck(unsigned long, b) && \
>>       ((long)(a) - (long)(b) >= 0))
>> #define time_before_eq(a,b)    time_after_eq(b,a)
> I might have misunderstood you but those macros do handle the
> wrap-around. For example, with 64-bit long and a = 1,
> b = 0xffffffffffffffff, you get
>
>    ((long)(b) - (long)(a)) = (-1) - (1) = -2 < 0
>
> so that time_after(1, 0xffffffffffffffff) is true. It will give correct
> results as long as the difference is less than half of range of the
> type.
>
>                                                           Michal Kubecek
>

OK, Now I see why it works.

Best Regards,
Ulf Samuelsson